﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;


namespace MVRPlugin {
	public class ButtonAction : MVRScript {

        protected bool position=false;

		public override void Init() 
        {
			try {
                position=false;
                object[] obj = GameObject.FindObjectsOfType(typeof (Atom));
                foreach (object o in obj)
                {
                    Atom atom = (Atom) o;
                    if(atom.type=="UIButton")
                    {
                        //SuperController.LogMessage(atom.name);
                        var text=atom.GetStorableByID("Text").GetStringJSONParam("text").val;
                        var enable_main_btn = CreateButton("["+atom.name+"]"+" - "+text, position);
                        enable_main_btn.button.onClick.AddListener(delegate{clickBtn(atom);});
                        JSONStorableAction click_btn_action = new JSONStorableAction("["+atom.name+"]"+" - "+text, () => {clickBtn(atom);});
                        RegisterAction(click_btn_action);
                        atom.GetStorableByID("Trigger").RegisterAction(click_btn_action);
                        position=!position;
                    }
                }
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		public void clickBtn (Atom atom)
		{
			var trigger = atom.GetStorableByID("Trigger");
			UIButtonTrigger t = trigger.GetComponent<UIButtonTrigger>();
			t.button.onClick.Invoke();
			//SuperController.LogMessage("clickBtn: button clicked!"+"");
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Update is called with each rendered frame by Unity
		void Update() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// FixedUpdate is called with each physics simulation frame by Unity
		void FixedUpdate() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// OnDestroy is where you should put any cleanup
		// if you registered objects to supercontroller or atom, you should unregister them here
		void OnDestroy() {
            object[] obj = GameObject.FindObjectsOfType(typeof (Atom));
                foreach (object o in obj)
                {
                    Atom atom = (Atom) o;
                    if(atom.type=="UIButton")
                    {
                        var text=atom.GetStorableByID("Text").GetStringJSONParam("text").val;
                        //JSONStorableAction click_btn_action = new JSONStorableAction("["+atom.name+"]"+" - "+text, () => {clickBtn(atom);});
                        atom.GetStorableByID("Trigger").DeregisterAction(atom.GetStorableByID("Trigger").GetAction("["+atom.name+"]"+" - "+text));
                        
                    }
                }
		}

	}
}